﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            this.calculateButton.Click += calculateButton_Click;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 계산하기 버튼 클릭시 처리하기 - calculateButton_Click(sender, e)

        /// <summary>
        /// 계산하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void calculateButton_Click(object sender, EventArgs e)
        {
            this.aplusBTextBox.Clear();
            this.aMinusBTextBox.Clear();
            this.aMultiplyBTextBox.Clear();
            this.aDivideBTextBox.Clear();
            this.negativeATextBox.Clear();
            this.doubleATextBox.Clear();

            try
            {
                Fraction a = new Fraction(this.aTextBox.Text);
                Fraction b = new Fraction(this.bTextBox.Text);

                this.aplusBTextBox.Text     = (a + b).ToString();
                this.aMinusBTextBox.Text    = (a - b).ToString();
                this.aMultiplyBTextBox.Text = (a * b).ToString();
                this.aDivideBTextBox.Text   = (a / b).ToString();
                this.negativeATextBox.Text  = (-a).ToString();
                this.doubleATextBox.Text    = ((double)a).ToString();
            }
            catch(Exception exception)
            {
                MessageBox.Show(exception.Message);
            }
        }

        #endregion
    }
}