﻿using System;

namespace TestProject
{
    /// <summary>
    /// 수학 헬퍼
    /// </summary>
    public static class MathHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 최대 공약수 구하기 - GetGreatestCommonDivisor(a, b)

        /// <summary>
        /// 최대 공약수 구하기
        /// </summary>
        /// <param name="a">A</param>
        /// <param name="b">B</param>
        /// <returns>최대 공약수</returns>
        public static long GetGreatestCommonDivisor(long a, long b)
        {
            a = Math.Abs(a);
            b = Math.Abs(b);

            if(a < b)
            {
                long temporary = a;

                a = b;
                b = temporary;
            }

            for(;;)
            {
                long remainder = a % b;

                if(remainder == 0)
                {
                    return b;
                }

                a = b;
                b = remainder;
            }
        }

        #endregion
        #region 최소 공배수 구하기 - GetLeastCommonMultiple(a, b)

        /// <summary>
        /// 최소 공배수 구하기
        /// </summary>
        /// <param name="a">A</param>
        /// <param name="b">B</param>
        /// <returns>최소 공배수</returns>
        public static long GetLeastCommonMultiple(long a, long b)
        {
            long gcd = GetGreatestCommonDivisor(a, b);

            return ((a / gcd) * (b / gcd)) * gcd;
        }

        #endregion
    }
}